VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   3705
   ClientLeft      =   165
   ClientTop       =   735
   ClientWidth     =   4680
   LinkTopic       =   "Form1"
   ScaleHeight     =   3705
   ScaleWidth      =   4680
   StartUpPosition =   3  'Windows Default
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin VB.Menu mnuData 
      Caption         =   "&Data"
      Begin VB.Menu mnuDataClear 
         Caption         =   "&Clear"
      End
      Begin VB.Menu mnuDataSep 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDataStyle 
         Caption         =   "Reflection X"
         Checked         =   -1  'True
         Index           =   0
      End
      Begin VB.Menu mnuDataStyle 
         Caption         =   "Reflection Y"
         Index           =   1
      End
      Begin VB.Menu mnuDataStyle 
         Caption         =   "Reflection XY"
         Index           =   2
      End
      Begin VB.Menu mnuDataStyle 
         Caption         =   "Rotation 2"
         Index           =   3
      End
      Begin VB.Menu mnuDataStyle 
         Caption         =   "Rotation 4"
         Index           =   4
      End
      Begin VB.Menu mnuDataStyle 
         Caption         =   "Rotation 8"
         Index           =   5
      End
      Begin VB.Menu mnuDataStyle 
         Caption         =   "Rotation Other"
         Index           =   6
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private m_Drawing As Boolean
Private m_X As Double
Private m_Y As Double
Private m_Cx As Double
Private m_Cy As Double

Private m_Angle As Double
Private m_CurrentStyle As String

Private Const PI As Double = 3.14159265

' Rotate the point (X, Y) around the point (cx, cy) by the given angle.
Private Sub RotatePointAround(ByVal cx As Double, ByVal cy As Double, ByVal angle As Double, ByRef X As Double, ByRef Y As Double)
Dim sin_angle As Double
Dim cos_angle As Double
Dim new_x As Double

    sin_angle = Sin(angle)
    cos_angle = Cos(angle)
    X = X - cx
    Y = Y - cy
    new_x = cx + X * cos_angle + Y * sin_angle
    Y = cy - X * sin_angle + Y * cos_angle
    X = new_x
End Sub

Private Sub Form_Load()
    Me.AutoRedraw = True
    mnuDataStyle_Click (0)
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_X = X
    m_Y = Y
    m_Drawing = True
End Sub


Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
Dim i As Integer
Dim angle As Double
Dim dx1 As Double
Dim dy1 As Double
Dim dx2 As Double
Dim dy2 As Double
Dim x1 As Double
Dim y1 As Double
Dim x2 As Double
Dim y2 As Double

    If Not m_Drawing Then Exit Sub

    Select Case m_CurrentStyle
        Case "Reflection X"
            Line (m_X, m_Y)-(X, Y)
            Line (2 * m_Cx - m_X, m_Y)-(2 * m_Cx - X, Y)
        Case "Reflection Y"
            Line (m_X, m_Y)-(X, Y)
            Line (m_X, 2 * m_Cy - m_Y)-(X, 2 * m_Cy - Y)
        Case "Reflection XY"
            Line (m_X, m_Y)-(X, Y)
            Line (2 * m_Cx - m_X, m_Y)-(2 * m_Cx - X, Y)
            Line (m_X, 2 * m_Cy - m_Y)-(X, 2 * m_Cy - Y)
            Line (2 * m_Cx - m_X, 2 * m_Cy - m_Y)-(2 * m_Cx - X, 2 * m_Cy - Y)
        Case "Rotation 2"
            Line (m_X, m_Y)-(X, Y)
            dx1 = m_X - m_Cx
            dy1 = m_Y - m_Cy
            dx2 = X - m_Cx
            dy2 = Y - m_Cy
            Line (m_Cx - dx1, m_Cy - dy1)-(m_Cx - dx2, m_Cy - dy2)
        Case "Rotation 4"
            Line (m_X, m_Y)-(X, Y)
            dx1 = m_X - m_Cx
            dy1 = m_Y - m_Cy
            dx2 = X - m_Cx
            dy2 = Y - m_Cy
            Line (m_Cx - dx1, m_Cy - dy1)-(m_Cx - dx2, m_Cy - dy2)
            Line (m_Cx - dy1, m_Cy + dx1)-(m_Cx - dy2, m_Cy + dx2)
            Line (m_Cx + dy1, m_Cy - dx1)-(m_Cx + dy2, m_Cy - dx2)
        Case "Rotation 8"
            x1 = m_X
            y1 = m_Y
            x2 = X
            y2 = Y
            For i = 1 To 8
                Line (x1, y1)-(x2, y2)
                RotatePointAround m_Cx, m_Cy, PI / 4, x1, y1
                RotatePointAround m_Cx, m_Cy, PI / 4, x2, y2
            Next i
        Case "Rotation Other"
            x1 = m_X
            y1 = m_Y
            x2 = X
            y2 = Y
            For i = 1 To CInt((2 * PI) / m_Angle)
                Line (x1, y1)-(x2, y2)
                RotatePointAround m_Cx, m_Cy, m_Angle, x1, y1
                RotatePointAround m_Cx, m_Cy, m_Angle, x2, y2
            Next i
    End Select

    m_X = X
    m_Y = Y
End Sub

Private Sub Form_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    m_Drawing = False
End Sub


Private Sub Form_Resize()
    m_Cx = ScaleWidth / 2
    m_Cy = ScaleHeight / 2
End Sub


Private Sub mnuDataClear_Click()
    Me.Cls
End Sub

Private Sub mnuDataStyle_Click(Index As Integer)
Dim i As Integer

    For i = mnuDataStyle.LBound To mnuDataStyle.uBound
        mnuDataStyle(i).Checked = (i = Index)
    Next i

    m_CurrentStyle = mnuDataStyle(Index).Caption
    If m_CurrentStyle = "Rotation Other" Then
        m_Angle = InputBox("Angle (degrees)", "Angle", 30)
        If m_Angle < 1 Then m_Angle = 1
        m_Angle = m_Angle * PI / 180
    End If

    Me.Cls
End Sub


Private Sub mnuFileExit_Click()
    Unload Me
End Sub


